/* Bruce's analog read program: modeled on Jeremy Bluhms sketch. 

Includes my rgb check loop that is commented out. I found this useful for 
establishing which LED pin to hook to which digital output pin on the Arduino.

I would note that it is a good idea to calibrate your light sensor buy
covering it (dark) and entering that analog value into MIN_LEVEL and
then putting the brightest light you expect and entering that value
into MAX_LEVEL.The map command then takes that range and distributes it 
between 0 and 255 which can be useful if you wish to use the PWM pins
to dim LED's or slow motors.

Exploring Arduino - Code Listing 3-2: Temperature Alert Sketch
http://www.exploringarduino.com/content/ch3

Copyright 2013 Jeremy Blum ( http://www.jeremyblum.com )
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License v3 as published by
the Free Software Foundation.

*/

const int GLED = 9;              // sets green led to pin 9
const int RLED = 10;             // sets red led to pin 10
const int BLED = 11;             // sets blue led to pin 11
const int MIN_LEVEL = 50;        // this sets expected analog read for low light level (dark)
const int MAX_LEVEL = 800;       // this sets the highest level of expected light  (bright)
const int LOWER_LIMIT = 200;     // these are the test values for lower and upper limits
const int UPPER_LIMIT = 100;     // these levels are reversed to test the map command's ability
                                 //  to reverse the sense of change, could be useful for motor control
const int LIGHT = 0;             // sets analog pin for light level read
int level = 0;                   // sets initial value of read variable to 0
int alevel = 0;                  // set default analog light level

void setup() {
  
  Serial.begin(9600); // initiallizes serial terminal to monitor output
  pinMode(RLED,OUTPUT);
  pinMode(GLED,OUTPUT);
  pinMode(BLED,OUTPUT);
  digitalWrite(RLED,HIGH);
  digitalWrite(GLED,HIGH);
  digitalWrite(BLED,HIGH);

}

void loop() {
  
  
/*  Test loop to verify pin assigments for LED's
 *   
  digitalWrite(RLED,LOW);
  delay(500);
    digitalWrite(RLED,HIGH);
  digitalWrite(GLED,LOW);
  delay(500);
    digitalWrite(GLED,HIGH);
  digitalWrite(BLED,LOW);
  delay(500);
    digitalWrite(BLED,HIGH);
*/

   level = analogRead(LIGHT);                      // reads the input analog level from sensor
   alevel = map(level,MIN_LEVEL,MAX_LEVEL,255,0);  // maps the analog level to a new range 
                                                   // -- not needed but handy to know, note 
                                                   // reversed output range just because 
    Serial.print("level: ");                       // output the two levels
    Serial.print(level);
    Serial.print(" alevel: ");
    Serial.println(alevel);
    
    if (alevel > LOWER_LIMIT)                      // choose LED indicator
    {  digitalWrite(RLED,LOW);
       digitalWrite(GLED,HIGH);
    }
    else if (alevel < UPPER_LIMIT)
    {  digitalWrite(BLED,LOW);
       digitalWrite(GLED,HIGH);
    }
    else 
    {  digitalWrite(RLED,HIGH);
       digitalWrite(BLED,HIGH);
       analogWrite(GLED,alevel);
    }
    delay(1500);                             // sets cycle time for checking


}
